<script>
    import { createEventDispatcher } from 'svelte'
    import { validateSelf } from 'lib/validate'

    export let name
    export let value
    export let rules

    const MAX_BIO_SIZE = 250
    const dispatch = createEventDispatcher()

    $: bioSize = value?.length || 0

    const initTextarea = (element, value) => {
        element.style.height = '1px'
        element.style.height = 24 + element.scrollHeight + 'px'
        return {
            update: () => {
                element.style.height = '1px'
                element.style.height = 24 + element.scrollHeight + 'px'
            },
        }
    }

    export const validate = async () => {
        const errors = await validateSelf(rules, value)
        dispatch('errors', errors)
        return errors.length === 0
    }
</script>

<textarea
    id={name}
    class:danger={bioSize >= MAX_BIO_SIZE}
    {name}
    use:initTextarea={value}
    on:input
    bind:value
/>
<span class:danger={bioSize > MAX_BIO_SIZE}>{bioSize}/{MAX_BIO_SIZE}</span>

<style lang="postcss">
    textarea {
        @apply w-full resize-none overflow-hidden text-teal-600;

        .danger {
            @apply text-red-500;
        }

        &:focus {
            @apply outline-none;
        }
    }

    span {
        @apply font-normal text-xs text-teal-600 self-end;

        &.danger {
            @apply text-red-500;
        }
    }
</style>
